return {
	"ThePrimeagen/harpoon",
	branch = "harpoon2",
	dependencies = {
		"nvim-lua/plenary.nvim",
	},
	config = function()
		local harpoon = require("harpoon")

		-- REQUIRED
		harpoon:setup()
		-- REQUIRED

		local keymap = vim.keymap

		keymap.set("n", "<leader>a", function()
			harpoon:list():add()
		end, { desc = "Mark file with harpoon" })

		keymap.set("n", "<C-e>", function()
			harpoon.ui:toggle_quick_menu(harpoon:list())
		end, { desc = "Toggle quick menu for harpoon" })

		keymap.set("n", "<leader>1", function()
			harpoon:list():select(1)
		end, { desc = "Go to first harpoon file" })

		keymap.set("n", "<leader>2", function()
			harpoon:list():select(2)
		end, { desc = "Go to second harpoon file" })

		keymap.set("n", "<leader>3", function()
			harpoon:list():select(3)
		end, { desc = "Go to third harpoon file" })

		keymap.set("n", "<leader>4", function()
			harpoon:list():select(4)
		end, { desc = "Go to fourth harpoon file" })
	end,
}
