return {
    "tovijaeschke/laravel.nvim",
    -- enabled = false,
    branch = "feature/discovery-check-improvements",
    dependencies = {
        "nvim-telescope/telescope.nvim",
        "tpope/vim-dotenv",
        "MunifTanjim/nui.nvim",
        -- "nvimtools/none-ls.nvim",
    },
    cmd = { "Sail", "Artisan", "Composer", "Npm", "Yarn", "Laravel" },
    keys = {
        { "<leader>la", ":Laravel artisan<cr>" },
        { "<leader>lr", ":Laravel routes<cr>" },
        { "<leader>lm", ":Laravel related<cr>" },
    },
    event = { "VeryLazy" },
    config = function ()
        local laravel = require("laravel")

        laravel.setup({
            lsp_server = "intelephense",
            features = {
                null_ls = {
                    enable = false,
                },
            },
            environments = {
                env_variable = "NVIM_LARAVEL_ENV",
                auto_dicover = false,
                default = "docker-compose",
                definitions = {
                    {
                      name = "sail",
                      condition = {
                        file_exists = { "vendor/bin/sail", "docker-compose.yml" },
                      },
                      commands = {
                        sail = { "vendor/bin/sail" },
                        {
                          commands = { "php", "composer", "npm", "yarn" },
                          prefix = { "vendor/bin/sail" },
                        },
                      },
                    },
                    {
                        name = "docker-compose",
                        condition = {
                            file_exists = { "docker-compose.yml" },
                            executable = { "docker" },
                        },
                        commands = {
                            compose = { "docker", "compose" },
                            {
                                commands = { "php", "composer", "npm" },
                                docker = {
                                    container = {
                                        env = "APP_SERVICE",
                                        default = "fpm",
                                    },
                                    exec = { "docker", "compose", "exec", "-it" },
                                },
                            },
                        },
                    },
                    {
                        name = "local",
                        condition = {
                            executable = { "php" },
                        },
                    },
                }
            }
        })
    end,
}
